package de.gc.db.jdbi;

import java.util.List;

import org.jdbi.v3.core.Handle;
import org.jdbi.v3.core.Jdbi;
import org.jdbi.v3.guava.GuavaPlugin;
import org.jdbi.v3.sqlobject.SqlObjectPlugin;

import de.gc.db.jdbi.oop.ort.Ort;
import de.gc.db.jdbi.oop.ort.OrtDAO;

public class T01_ort {

   public static void main(final String[] args) {

      final Jdbi jdbi = Jdbi.create("jdbc:mariadb://localhost:3306/bsp", "bsp", "");

      System.out.println("Connect bsp ...");

      jdbi.installPlugin(new SqlObjectPlugin());
      jdbi.installPlugin(new GuavaPlugin());
      final Handle handle = jdbi.open();

      final OrtDAO ortDao = handle.attach(OrtDAO.class);

      ortDao.createTable();

      final Ort o1 = new Ort("München", "12345");
      long pk = ortDao.insert(o1);
      System.out.println("inserted PK = " + pk);

      pk = ortDao.insert("Haimhausen", "85778");
      System.out.println("inserted PK = " + pk);

      System.out.println("##########################");
      final List<Ort> list = ortDao.getAll();
      list.stream()
            .forEach(e -> System.out.println(e));
      System.out.println("##########################");
      final Ort o = ortDao.findById(1);
      System.out.println(o);

   }

}
