package de.gc.db.jdbi;

import java.util.List;
import java.util.Map;
import java.util.stream.IntStream;

import org.jdbi.v3.core.Handle;
import org.jdbi.v3.core.Jdbi;
import org.jdbi.v3.guava.GuavaPlugin;
import org.jdbi.v3.sqlobject.SqlObjectPlugin;

import de.gc.db.jdbi.oop.kunde.KundeDAO;
import de.gc.db.jdbi.oop.ort.OrtDAO;

public class T02_kunde_ort {

   public static void main(final String[] args) {

      final Jdbi jdbi = Jdbi.create("jdbc:mariadb://localhost:3306/bsp", "bsp", "");

      System.out.println("Connect bsp ...");

      jdbi.installPlugin(new SqlObjectPlugin());
      jdbi.installPlugin(new GuavaPlugin());
      final Handle handle = jdbi.open();

      final KundeDAO kundeDao = handle.attach(KundeDAO.class);
      final OrtDAO ortDao = handle.attach(OrtDAO.class);

      handle.execute("DROP TABLE IF EXISTS kunde");
      handle.execute("DROP TABLE IF EXISTS ort");
      kundeDao.createTable();
      ortDao.createTable();

      IntStream.rangeClosed(1, 5)
            .forEach(o -> handle.execute("""
                  INSERT INTO ort (id, name, plz) VALUES (?, ?, ?)
                  """, o, "o_" + o, "p_" + o));
      final String sql = "INSERT INTO kunde (id, name, oid) VALUES (?, ?, ?)";
      handle.execute(sql, 1, "k_1", 1);
      handle.execute(sql, 2, "k_2", 3);
      handle.execute(sql, 3, "k_3", 5);
      handle.execute(sql, 4, "k_4", null);

      System.out.println("Ort -----------------");
      final List<Map<String, Object>> rso = handle.createQuery("SELECT * FROM ort")
            .mapToMap()
            .list();
      rso.stream()
            .forEach(e -> System.out.println(e));
      System.out.println("Kunde -----------------");
      final List<Map<String, Object>> rsu = handle.createQuery("SELECT * FROM kunde")
            .mapToMap()
            .list();
      rsu.stream()
            .forEach(e -> System.out.println(e));
   }

}
