package de.gc.db.jdbi;

import java.util.List;

import org.jdbi.v3.core.Handle;
import org.jdbi.v3.core.Jdbi;
import org.jdbi.v3.guava.GuavaPlugin;
import org.jdbi.v3.sqlobject.SqlObjectPlugin;

import de.gc.db.jdbi.oop.kunde.Kunde;
import de.gc.db.jdbi.oop.kunde.KundeDAO;
import de.gc.db.jdbi.oop.ort.OrtDAO;

public class T03_kunde_ort_1N {

   public static void main(final String[] args) {

      final Jdbi jdbi = Jdbi.create("jdbc:mariadb://localhost:3306/bsp", "bsp", "");

      System.out.println("Connect bsp ...");

      jdbi.installPlugin(new SqlObjectPlugin());
      jdbi.installPlugin(new GuavaPlugin());
      final Handle handle = jdbi.open();

      final KundeDAO kundeDao = handle.attach(KundeDAO.class);
      final OrtDAO ortDao = handle.attach(OrtDAO.class);

      System.out.println("##########################");
      final List<Kunde> list = kundeDao.getAll();
      list.stream()
            .forEach(e -> System.out.println(e));

      final Kunde u = new Kunde("Franz", ortDao.findById(1));
      u.setId(kundeDao.insert(u));
      System.out.println("-----------------------");
      System.out.println(u);

   }

}
