package de.gc.db.jdbi;

import java.util.List;
import java.util.Map;
import java.util.stream.IntStream;

import org.jdbi.v3.core.Handle;
import org.jdbi.v3.core.Jdbi;
import org.jdbi.v3.guava.GuavaPlugin;
import org.jdbi.v3.sqlobject.SqlObjectPlugin;

import de.gc.db.jdbi.oop.artikel.ArtikelDAO;
import de.gc.db.jdbi.oop.bespos.BesPosDAO;

public class T04_artikel_bespos {

   public static void main(final String[] args) {

      final Jdbi jdbi = Jdbi.create("jdbc:mariadb://localhost:3306/bsp", "bsp", "");

      System.out.println("Connect bsp ...");

      jdbi.installPlugin(new SqlObjectPlugin());
      jdbi.installPlugin(new GuavaPlugin());
      final Handle handle = jdbi.open();

      final ArtikelDAO artikelDao = handle.attach(ArtikelDAO.class);
      final BesPosDAO besposDao = handle.attach(BesPosDAO.class);

      handle.execute("DROP TABLE IF EXISTS artikel");
      handle.execute("DROP TABLE IF EXISTS bespos");
      artikelDao.createTable();
      besposDao.createTable();

      IntStream.rangeClosed(1, 5)
            .forEach(a -> handle.execute("INSERT INTO artikel (id, name) VALUES (?, ?)", a, "a_" + a));

      handle.execute("INSERT INTO bespos (aid, kid) VALUES (?, ?)", 1, 1);
      handle.execute("INSERT INTO bespos (aid, kid) VALUES (?, ?)", 2, 1);
      handle.execute("INSERT INTO bespos (aid, kid) VALUES (?, ?)", 3, 1);
      handle.execute("INSERT INTO bespos (aid, kid) VALUES (?, ?)", 5, 1);
      handle.execute("INSERT INTO bespos (aid, kid) VALUES (?, ?)", 1, 2);
      handle.execute("INSERT INTO bespos (aid, kid) VALUES (?, ?)", 3, 3);
      handle.execute("INSERT INTO bespos (aid, kid) VALUES (?, ?)", 3, 4);
      handle.execute("INSERT INTO bespos (aid, kid) VALUES (?, ?)", 4, 2);

      System.out.println("Artikel -----------------");
      final List<Map<String, Object>> rs = handle.createQuery("SELECT * FROM artikel")
            .mapToMap()
            .list();
      rs.stream()
            .forEach(e -> System.out.println(e));

      System.out.println("BesPos -----------------");
      final List<Map<String, Object>> rsbp = handle.createQuery("SELECT * FROM bespos")
            .mapToMap()
            .list();
      rsbp.stream()
            .forEach(e -> System.out.println(e));

   }

}
