package de.gc.db.jdbi;

import org.jdbi.v3.core.Handle;
import org.jdbi.v3.core.Jdbi;
import org.jdbi.v3.guava.GuavaPlugin;
import org.jdbi.v3.sqlobject.SqlObjectPlugin;

import com.google.common.collect.HashMultimap;
import com.google.common.collect.Multimap;

import de.gc.db.jdbi.oop.artikel.Artikel;
import de.gc.db.jdbi.oop.bespos.BesPosDAO;
import de.gc.db.jdbi.oop.kunde.Kunde;

public class T05_kunde_artikel_NM {

   public static void main(final String[] args) {

      final Jdbi jdbi = Jdbi.create("jdbc:mariadb://localhost:3306/bsp", "bsp", "");

      System.out.println("Connect bsp ...");

      jdbi.installPlugin(new SqlObjectPlugin());
      jdbi.installPlugin(new GuavaPlugin());
      final Handle handle = jdbi.open();

      final Multimap<Kunde, Artikel> joined = HashMultimap.create();
      handle.attach(BesPosDAO.class)
            .getKundeArtikel()
            .forEach(jr -> joined.put(jr.get(Kunde.class), jr.get(Artikel.class)));

      System.out.println("##########################");
      joined.keySet()
            .stream()
            .sorted()
            .forEach(k -> {
               System.out.println(k);
               joined.get(k)
                     .stream()
                     .sorted()
                     .forEach(a -> System.out.println("   " + a));
            });

   }
}
