package de.gc.db.jdbi.oop.artikel;

import java.beans.ConstructorProperties;

import org.jdbi.v3.core.mapper.reflect.ColumnName;

import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@NoArgsConstructor
public class Artikel implements Comparable<Artikel> {

   @ColumnName("a_id")
   private Long id;

   @ColumnName("a_name")
   private String name;

   @ConstructorProperties({ "a_id", "a_name" })
   public Artikel(final Long id, final String name) {
      this.id = id;
      this.name = name;
   }

   public Artikel(final String name) {
      this.name = name;
   }

   @Override
   public int compareTo(final Artikel o) {
      return name.compareTo(o.getName());
   }
}
