package de.gc.db.jdbi.oop.artikel;

import java.util.List;

import org.jdbi.v3.sqlobject.config.RegisterBeanMapper;
import org.jdbi.v3.sqlobject.customizer.Bind;
import org.jdbi.v3.sqlobject.customizer.BindBean;
import org.jdbi.v3.sqlobject.statement.GetGeneratedKeys;
import org.jdbi.v3.sqlobject.statement.SqlQuery;
import org.jdbi.v3.sqlobject.statement.SqlUpdate;

public interface ArtikelDAO {

   @SqlUpdate("""
         CREATE TABLE IF NOT EXISTS artikel (
            id      INT         PRIMARY KEY AUTO_INCREMENT,
            name    VARCHAR(50)
         ) ENGINE=InnoDB DEFAULT CHARSET=utf8
         """)
   void createTable();

   @SqlQuery("SELECT * FROM artikel WHERE id=:id")
   @RegisterBeanMapper(Artikel.class)
   Artikel findById(@Bind("id") int id);

   @SqlQuery("SELECT * FROM artikel")
   @RegisterBeanMapper(Artikel.class)
   List<Artikel> getAll();

   @SqlUpdate("""
         INSERT INTO artikel (name)
            VALUES (:name)
         """)
   @GetGeneratedKeys("id")
   long insert(@BindBean Artikel artikel);

   @SqlUpdate("""
         INSERT INTO artikel (name)
            VALUES (:name)
         """)
   @GetGeneratedKeys("id")
   long insert(@Bind("name") String name);
}
