package de.gc.db.jdbi.oop.kunde;

import java.beans.ConstructorProperties;

import org.jdbi.v3.core.mapper.Nested;
import org.jdbi.v3.core.mapper.reflect.ColumnName;

import de.gc.db.jdbi.oop.ort.Ort;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@NoArgsConstructor
public class Kunde implements Comparable<Kunde> {

   @ColumnName("k_id")
   private Long id;

   @ColumnName("k_name")
   private String name = "";

   @Nested
   private Ort ort;

   public Kunde(final Long id, final String name) {
      this.id = id;
      this.name = name;
   }

   @ConstructorProperties({ "k_id", "k_name", "o_id", "o_name", "o_plz" })
   public Kunde(final Long id, final String name, final Long oid, final String oname,
         final String oplz) {
      this.id = id;
      this.name = name;
      if (oid != null) {
         ort = new Ort(oid, oname, oplz);
      }
   }

   public Kunde(final String name) {
      this.name = name;
   }

   public Kunde(final String name, final Ort ort) {
      this.name = name;
      this.ort = ort;
   }

   @Override
   public int compareTo(final Kunde k) {
      return name.compareTo(k.getName());
   }
}
