package de.gc.db.jdbi.oop.kunde;

import java.util.List;

import org.jdbi.v3.sqlobject.config.RegisterBeanMapper;
import org.jdbi.v3.sqlobject.config.RegisterRowMapper;
import org.jdbi.v3.sqlobject.customizer.Bind;
import org.jdbi.v3.sqlobject.customizer.BindBean;
import org.jdbi.v3.sqlobject.statement.GetGeneratedKeys;
import org.jdbi.v3.sqlobject.statement.SqlQuery;
import org.jdbi.v3.sqlobject.statement.SqlUpdate;

public interface KundeDAO {

   @SqlUpdate("""
         CREATE TABLE IF NOT EXISTS kunde (
           id      INT         PRIMARY KEY AUTO_INCREMENT,
           name    VARCHAR(50),
           oid     INT
         ) ENGINE=InnoDB DEFAULT CHARSET=utf8
         """)
   void createTable();

   @SqlQuery("SELECT * FROM kunde WHERE id=:id")
   @RegisterBeanMapper(Kunde.class)
   Kunde findById(@Bind("id") int id);

   @SqlQuery("""
         SELECT k.id AS k_id, k.name AS k_name, k.oid AS k_oid,
                o.name AS o_name, o.plz AS o_plz
            FROM kunde k LEFT JOIN ort o ON k.oid=o.id
         """)
   @RegisterRowMapper(KundeMapper.class)
   List<Kunde> getAll();

   @SqlUpdate("""
         INSERT INTO kunde (name, oid)
            VALUES (:name, :ort.id)
         """)
   @GetGeneratedKeys("id")
   long insert(@BindBean Kunde user);
}
