package de.gc.db.jdbi.oop.kunde;

import java.sql.ResultSet;
import java.sql.SQLException;

import org.jdbi.v3.core.mapper.RowMapper;
import org.jdbi.v3.core.statement.StatementContext;

import de.gc.db.jdbi.oop.ort.Ort;

public class KundeMapper implements RowMapper<Kunde> {

   @Override
   public Kunde map(final ResultSet rs, final StatementContext ctx) throws SQLException {
      // debug - Spaltenüberschriften ausgeben
      // final ResultSetMetaData meta = rs.getMetaData();
      // for (int i = 1, n = meta.getColumnCount(); i <= n; i++) {
      // System.out.print(meta.getColumnLabel(i) + " ");
      // }
      // System.out.println();
      // ------------

      final Kunde k = new Kunde();
      k.setId(rs.getLong("k_id"));
      k.setName(rs.getString("k_name"));

      final Long oid = rs.getLong("k_oid");
      // ein null-Wert in der Spalte wird bei getLong() mit '0' umgesetzt - Zähler
      // beginnt bei '1'
      if (oid != 0) {
         k.setOrt(new Ort(oid, rs.getString("o_name"), rs.getString("o_plz")));
      }
      return k;
   }
}
