package de.gc.db.jdbi.oop.ort;

import java.util.List;

import org.jdbi.v3.sqlobject.config.RegisterBeanMapper;
import org.jdbi.v3.sqlobject.customizer.Bind;
import org.jdbi.v3.sqlobject.customizer.BindBean;
import org.jdbi.v3.sqlobject.statement.GetGeneratedKeys;
import org.jdbi.v3.sqlobject.statement.SqlQuery;
import org.jdbi.v3.sqlobject.statement.SqlUpdate;

public interface OrtDAO {

   @SqlUpdate("""
         CREATE TABLE IF NOT EXISTS ort (
            id      INT         PRIMARY KEY AUTO_INCREMENT,
            name    VARCHAR(50),
            plz     VARCHAR(10)
         ) ENGINE=InnoDB DEFAULT CHARSET=utf8
         """)
   void createTable();

   @SqlQuery("SELECT * FROM ort WHERE id=:id")
   @RegisterBeanMapper(Ort.class)
   Ort findById(@Bind("id") int id);

   @SqlQuery("SELECT * FROM ort")
   @RegisterBeanMapper(Ort.class)
   List<Ort> getAll();

   @SqlUpdate("""
         INSERT INTO ort (name, plz)
            VALUES (:name, :plz)
         """)
   @GetGeneratedKeys("id")
   long insert(@BindBean Ort ort);

   @SqlUpdate("""
         INSERT INTO ort (name, plz)
            VALUES (:name, :plz)
         """)
   @GetGeneratedKeys("id")
   long insert(@Bind("name") String name, @Bind("plz") String plz);
}
